﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using VisualPoint.Controls.Environments;

namespace VisualPoint.Controls.Actions
{
    public class ListItemCollection : Collection<ListItem>
    {
        private static ListItemCollection _ViewKinds;
        public static ListItemCollection ViewKinds
        {
            get
            {
                if (_ViewKinds == null)
                {
                    CreateViewKindItems();
                }
                return _ViewKinds;
            }
        }

        private static void CreateViewKindItems()
        {
            _ViewKinds = new ListItemCollection();

            _ViewKinds.ViewKindAdd(DteConstants.vsViewKindAny, "Any");
            _ViewKinds.ViewKindAdd(DteConstants.vsViewKindCode, "Code");
            _ViewKinds.ViewKindAdd(DteConstants.vsViewKindDebugging, "Debugging");
            _ViewKinds.ViewKindAdd(DteConstants.vsViewKindDesigner, "Designer");
            _ViewKinds.ViewKindAdd(DteConstants.vsViewKindPrimary, "Primary");
            _ViewKinds.ViewKindAdd(DteConstants.vsViewKindTextView, "Text View");
        }

        private void ViewKindAdd(string id, string name)
        {
            _ViewKinds.Add(new ListItem(id, name));
        }



    }
}
