﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using VisualPoint.Controls.Environments;

namespace VisualPoint.Controls.Actions
{
    public class StandardWindowItemDictionary :  Dictionary<string, StandardWindowItem>
    {

        private static StandardWindowItemCollection _Default;
        public static StandardWindowItemCollection Default
        {
            get
            {
                if (_Default == null)
                {
                    _Default = new StandardWindowItemCollection();

                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindAutoLocals, "Auto Locals"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindCallStack, "Call Stack"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindClassView, "Class View"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindCommandWindow, "Command Window"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindDocumentOutline, "Document Outline"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindDynamicHelp, "Dynamic Help"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindFindReplace, "Find Replace"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindFindResults1, "Find Results 1"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindFindResults2, "Find Results 2"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindFindSymbol, "Symbol"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindFindSymbolResults, "Symbol Results"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindLinkedWindowFrame, "Linked Window Frame"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindLocals, "Locals"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindMacroExplorer, "Macro Explorer"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindMainWindow, "Main Window"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindObjectBrowser, "Object Browser"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindOutput, "Output"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindProperties, "Properties"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindResourceView, "Resource View"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindServerExplorer, "Server Explorer"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindSolutionExplorer, "Solution Explorer"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindTaskList, "Task List"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindThread, "Thread"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindToolbox, "Toolbox"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindWatch, "Watch"));
                    _Default.Add(new StandardWindowItem(DteConstants.vsWindowKindWebBrowser, "Web Browser")); 
                }
                return _Default;
            }
        }

    }
}
