﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using VisualPoint.Controls.Models;

namespace VisualPoint.Controls.Actions
{
    public class TextWriteAction : BaseAction
    {

        public override string Name
        {
            get
            {
                return "Write Text";
            }
        }

        public override string Description
        {
            get
            {

                return Text;

            }
        }

        public override string Help
        {
            get
            {
                return "Writes the text in the current open file.";
            }
        }
        public override BaseActionModel CreateModel()
        {
            return new TextWriteActionModel() { Action = this };
        }

        private string _text;
        public string Text
        {
            get
            {
                return _text;
            }
            set
            {
                if (_text != value)
                {
                    _text = value;
                    DoPropertyChanged("Text");
                    DoDescriptionChanged();
                }
            }
        }



        public override void Run()
        {
            VisualPoint.Controls.Environments.Environment.Current.WriteText(Text);
        }

        public override void InitializeNew()
        {
            Text = VisualPoint.Controls.Environments.Environment.Current.GetSelectedText();
        }

    }
}
