﻿ 
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using VisualPoint.Controls.Actions;
using VisualPoint.Controls.Commands;
using VisualPoint.Controls.Models;

namespace VisualPoint.Controls.ViewModels
{
    public partial class ActionListViewModel : 

	ICopy,
	IDelete,
	IEdit,
	IRun,
	IWindowConfiguration,
	IFileCloseAction,
	IFileOpenAction,
	IMoveItemDown,
	IMoveItemUp,
	IPaste,
	ITextSelectAction,
	ITextWriteAction,
	IResizeAction,
	IWindowSelectAction	
	{
        #region ICopy

        partial void DoCopy();

        public void Copy()
        {
            DoCopy();
        }

        private CopyCommand _CopyCommand;
        public CopyCommand CopyCommand
        {
            get { return _CopyCommand; }
        }

        #endregion

        #region IDelete

        partial void DoDelete();

        public void Delete()
        {
            DoDelete();
        }

        private DeleteCommand _DeleteCommand;
        public DeleteCommand DeleteCommand
        {
            get { return _DeleteCommand; }
        }

        #endregion

        #region IEdit

        partial void DoEdit();

        public void Edit()
        {
            DoEdit();
        }

        private EditCommand _EditCommand;
        public EditCommand EditCommand
        {
            get { return _EditCommand; }
        }

        #endregion

        #region IRun

        partial void DoRun();

        public void Run()
        {
            DoRun();
        }

        private RunCommand _RunCommand;
        public RunCommand RunCommand
        {
            get { return _RunCommand; }
        }

        #endregion

        #region IWindowConfiguration

        partial void DoWindowConfiguration();

        public void WindowConfiguration()
        {
            DoWindowConfiguration();
        }

        private WindowConfigurationCommand _WindowConfigurationCommand;
        public WindowConfigurationCommand WindowConfigurationCommand
        {
            get { return _WindowConfigurationCommand; }
        }

        #endregion

        #region IFileCloseAction

        partial void DoFileCloseAction();

        public void FileCloseAction()
        {
            DoFileCloseAction();
        }

        private FileCloseActionCommand _FileCloseActionCommand;
        public FileCloseActionCommand FileCloseActionCommand
        {
            get { return _FileCloseActionCommand; }
        }

        #endregion

        #region IFileOpenAction

        partial void DoFileOpenAction();

        public void FileOpenAction()
        {
            DoFileOpenAction();
        }

        private FileOpenActionCommand _FileOpenActionCommand;
        public FileOpenActionCommand FileOpenActionCommand
        {
            get { return _FileOpenActionCommand; }
        }

        #endregion

        #region IMoveItemDown

        partial void DoMoveItemDown();

        public void MoveItemDown()
        {
            DoMoveItemDown();
        }

        private MoveItemDownCommand _MoveItemDownCommand;
        public MoveItemDownCommand MoveItemDownCommand
        {
            get { return _MoveItemDownCommand; }
        }

        #endregion

        #region IMoveItemUp

        partial void DoMoveItemUp();

        public void MoveItemUp()
        {
            DoMoveItemUp();
        }

        private MoveItemUpCommand _MoveItemUpCommand;
        public MoveItemUpCommand MoveItemUpCommand
        {
            get { return _MoveItemUpCommand; }
        }

        #endregion

        #region IPaste

        partial void DoPaste();

        public void Paste()
        {
            DoPaste();
        }

        private PasteCommand _PasteCommand;
        public PasteCommand PasteCommand
        {
            get { return _PasteCommand; }
        }

        #endregion

        #region ITextSelectAction

        partial void DoTextSelectAction();

        public void TextSelectAction()
        {
            DoTextSelectAction();
        }

        private TextSelectActionCommand _TextSelectActionCommand;
        public TextSelectActionCommand TextSelectActionCommand
        {
            get { return _TextSelectActionCommand; }
        }

        #endregion

        #region ITextWriteAction

        partial void DoTextWriteAction();

        public void TextWriteAction()
        {
            DoTextWriteAction();
        }

        private TextWriteActionCommand _TextWriteActionCommand;
        public TextWriteActionCommand TextWriteActionCommand
        {
            get { return _TextWriteActionCommand; }
        }

        #endregion

        #region IResizeAction

        partial void DoResizeAction();

        public void ResizeAction()
        {
            DoResizeAction();
        }

        private ResizeActionCommand _ResizeActionCommand;
        public ResizeActionCommand ResizeActionCommand
        {
            get { return _ResizeActionCommand; }
        }

        #endregion

        #region IWindowSelectAction

        partial void DoWindowSelectAction();

        public void WindowSelectAction()
        {
            DoWindowSelectAction();
        }

        private WindowSelectActionCommand _WindowSelectActionCommand;
        public WindowSelectActionCommand WindowSelectActionCommand
        {
            get { return _WindowSelectActionCommand; }
        }

        #endregion


        private void CreateCommands()
        {
			_CopyCommand = new CopyCommand(this);
			_DeleteCommand = new DeleteCommand(this);
			_EditCommand = new EditCommand(this);
			_RunCommand = new RunCommand(this);
			_WindowConfigurationCommand = new WindowConfigurationCommand(this);
			_FileCloseActionCommand = new FileCloseActionCommand(this);
			_FileOpenActionCommand = new FileOpenActionCommand(this);
			_MoveItemDownCommand = new MoveItemDownCommand(this);
			_MoveItemUpCommand = new MoveItemUpCommand(this);
			_PasteCommand = new PasteCommand(this);
			_TextSelectActionCommand = new TextSelectActionCommand(this);
			_TextWriteActionCommand = new TextWriteActionCommand(this);
			_ResizeActionCommand = new ResizeActionCommand(this);
			_WindowSelectActionCommand = new WindowSelectActionCommand(this);
        }

	}
}
